package org.itscool.stylist.io;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;

import org.itscool.stylist.tag.HtmlTag;

/**
 * XHTMLに含まれるシンプルタグ情報を応答データに変換します
 * @author kano
 * @version 1.00A 2006/08/09 新規作成
 */
public class HtmlSimpleTagConverter extends HtmlConverter {
//    /**
//     * インスタンスの初期化を行います
//     * @param context ServletContextインスタンス
//     * @param req HttpServletRequestインスタンス
//     */
//    public HtmlSimpleTagConverter(ServletContext context, HttpServletRequest req) {
//        super(context, req);
//    }
    
    /**
     * 応答用のXHTMLデータの作成を開始します
     * @param node HtmlTagインスタンス
     * @return 応答データ
     */
    public String convert(HtmlTag node, String tab) {
//        HtmlAttributeConverter attrCnv = new HtmlAttributeConverter(context, req);
        HtmlAttributeConverter attrCnv = new HtmlAttributeConverter();
        attrCnv.init(context, req);
        String tagName = node.getTagName();
        StringBuffer sb = new StringBuffer();
        int size = node.size();
        
        sb.append(tab);
        sb.append("<").append(tagName);
        sb.append(attrCnv.convert(node));
        if( (node.getTagName().equals(HtmlTag.TAG_HTML)
        || node.getTagName().equals(HtmlTag.TAG_HEAD)
//		|| node.getTagName().equals(HtmlTag.TAG_TITLE)
        || node.getTagName().equals(HtmlTag.TAG_SCRIPT)
        || node.getTagName().equals(HtmlTag.TAG_STYLE)
        || node.getTagName().equals(HtmlTag.TAG_BODY)
        ) && size == 0){
            sb.append("></").append(node.getTagName()).append(">").append(LINE);
        }else{
//            sb.append("/>").append(LINE);
            sb.append("/>");
        }
        for(int i=0; i<size; i++ ){
            HtmlTag child = (HtmlTag)node.get(i);
//            sb.append(super.convert(child, tab + "  "));
            sb.append(super.convert(child, ""));
        }
        sb.append(LINE);
        return sb.toString();
    }
    
}
